﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel.Description;
using System.Text;
using System.Threading.Tasks;

namespace WcfTest.Extends
{
    // 实现可用于扩展服务或客户端应用程序中的终结点的运行时行为的方法。
    public class ChesEndpointBehavior : IEndpointBehavior
    {
         //实现此方法可以在运行时将数据传递给绑定，从而支持自定义行为。
        public void AddBindingParameters(ServiceEndpoint endpoint, 
            System.ServiceModel.Channels.BindingParameterCollection bindingParameters)
        {
           // throw new NotImplementedException();
        }

        //在终结点范围内实现客户端的修改或扩展。 -客户端
        public void ApplyClientBehavior(ServiceEndpoint endpoint,
            System.ServiceModel.Dispatcher.ClientRuntime clientRuntime)
        {
          //  throw new NotImplementedException();
            clientRuntime.MessageInspectors.Add(new ChesClientMessageInspector());  
        }

        //在终结点范围内实现服务的修改或扩展。 -服务
        public void ApplyDispatchBehavior(ServiceEndpoint endpoint,
            System.ServiceModel.Dispatcher.EndpointDispatcher endpointDispatcher)
        {
            endpointDispatcher.DispatchRuntime.MessageInspectors.Add(new ChesDispatchMessageInspector());
        }

        // 实现此方法可以确认终结点是否满足某些设定条件。
        public void Validate(ServiceEndpoint endpoint)
        {
           // throw new NotImplementedException();
        }
    }
}
